/*
Laboratoire 13 (Fichiers)
Question 4:

crire une fonction qui lit un fichier texte contenant des tempratures (une temprature par ligne), 
et qui renvoie la temprature moyenne.
*/
#define _CRT_SECURE_NO_WARNINGS

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>


#define TAILLE_MAX_CHAINE 300 //Taille maximale du buffer stockant une chaine de caractres.

/*
TEMPERATURE_MOYENNE_FICHIER
Fonction qui lit le contenu d'un fichier texte contenant des temperatures. Elle retourne 
la moyenne des tempratures contenues dans le fichier. 

Le fichier doit contenir une temprature par ligne. La lecture s'arrte ds qu'on n'est plus
en mesure de reconnaitre une temprature (fin de fichier atteinte ou donne errone rencontre
dans le fichier.

La fonction lve une exception si l'ouverture du fichier choue.

PARAMTRES:
- nom_fichier (chaine de caractres): Le nom du fichier de temperatures  lire.
Retour:
Rel reprsentant la moyenne des tempratures lues. 0 si aucune temprature dans le fichier.
*/
double temperature_moyenne_fichier(char* nom_fichier) {
	double somme_temps = 0 ; //La somme des tempratures lues
	double temperature_lue; //Stocke la dernire temprature lue. 
	int nb_temperatures = 0; //Le nombre total de tempratures lues dans le fichier
	FILE *fichier; //Rfrence vers le fichier  lire
	int resultat_lecture; //Stocke le code retourn par fscanf nous permettant de savoir si on fini de lire
						  //ou si on doit continuer.

	//On ouvre le fichier en lecture et on s'assure que a a bien fonctionn
	fichier = fopen(nom_fichier, "r");
	assert(fichier != NULL);

	//NDE: fscanf retourne le nombre de d'lments qu'il a russi  lire dans le
	//fichier, selon le format fourni. Ici le format fourni est "%lf", donc on veut lire
	//un seul double. Si fscanf a russi  lire un double, il nous retournera 1. Sinon
	//il nous retourne 0. En retournant 0 (i.e. faux) on ne rentre pas dans le while (donc on 
	//ignore la valeur dans temperature_lue) et on arrte la lecture. Si elle retourne 1, on 
	//rentre dans le while et on traite temperature_lue. 
	//
	//Le scanf retourne galement EOF si on a atteint la fin du fichier (EOF est une constante
	//qui vaut -1, une valeur VRAIE). On doit traiter ce cas galement et arrter la lecture le
	//cas chant.
	while ( (resultat_lecture = fscanf(fichier, "%lf ", &temperature_lue)) &&  resultat_lecture !=EOF ) {
		somme_temps += temperature_lue;
		nb_temperatures++;
	}

	//On ferme le fichier
	fclose(fichier);
	
	// Cas o on n'a russi  lire aucune temprature.
	if (!nb_temperatures) {
		return 0;
	}

	//On calcule la moyenne et on la retourne.
	return somme_temps / nb_temperatures;
}

int main(void) {
	char nom_fichier[TAILLE_MAX_CHAINE]; //Le nom du fichier contenant des tempratures.
	double moyenne; //La moyenne des tempratures

	FILE* fichier; //Handle vers le fichier o on stocke la saisie.

				   //Saisie du nom de fichier  lire
	printf("Veuillez saisir le nom du fichier contenant des tempratures: ");
	fgets(nom_fichier, TAILLE_MAX_CHAINE, stdin);
	//On ne veut pas de \n dans le nom de fichier, on l'enlve: 
	nom_fichier[strlen(nom_fichier) - 1] = '\0';

	moyenne = temperature_moyenne_fichier(nom_fichier);
	
	printf("Moyenne des tempratures: %.2lf\n\n", moyenne);


	system("pause");
	return EXIT_SUCCESS;
}